<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead>
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>

</html>
<script>
    $(document).ready(function () {
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        onPageLoading();
        $(document).on("click",".btn-edit", function(){
            console.log("Click nút sửa!");
            onBtnEditClick(this);
        })
        $(document).on("click",".btn-delete", function(){
            console.log("Click nút xóa!");
            onBtnDeleteClick(this);
        })
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm xử lý khi click nút sửa
        // Input là nút được click
        function onBtnEditClick(paramEdit){
            "use strict";
            var vId = $(paramEdit).data("id");
            console.log("Id của user: " + vId);
            const vDETAIL_FORM_URL = "updateUser.html";
            var vUrlOpenSiter = vDETAIL_FORM_URL + "?id=" +vId ;
            window.location.href = vUrlOpenSiter;
        }
        // Hàm xử lý khi click nút xóa
        // Input là nút được click
        function onBtnDeleteClick(paramDelete){
            "use strict";
            var vId = $(paramDelete).data("id");
            console.log("Id của user: " + vId);
        }
        function onPageLoading() {
            "use strict";
            console.log("Tải trang thành công");
            $.ajax({
                url: "http://203.171.20.210:8080/crud-api/users/",
                type: 'GET',
                dataType: 'json', // added data type
                success: function (data) {
                    console.log(data);
                    fillDataToTable(data);
                },
                error: function (loi) {
                    alert(loi.responseText);
                }
            });
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm đổ dữ liệu vào table
        // Input là dữ liệu cần đổ vào bảng
        function fillDataToTable(paramData) {
            "use strict";
            for (var bI = 0; bI < paramData.length; bI++) {
                var bRow = "";
                bRow += "<tr>";
                    bRow += "<td>" + paramData[bI].id + "</td>";
                    bRow += "<td>" + paramData[bI].firstname + "</td>";
                    bRow += "<td>" + paramData[bI].lastname + "</td>";
                    bRow += "<td>" + paramData[bI].country + "</td>";
                    bRow += "<td>" + paramData[bI].subject + "</td>";
                    bRow += "<td>" + paramData[bI].customerType + "</td>";
                    bRow += "<td>" + paramData[bI].registerStatus + "</td>";
                    bRow += "<td><button class='btn btn-primary btn-edit' data-id='" + paramData[bI].id + "'>Sửa</button> <button class='btn btn-danger btn-delete' data-id='" + paramData[bI].id + "'>Xóa</button></td>";
                bRow += "</tr>";
                $("#table-users tbody").append(bRow);
            }

        }
    })
</script>